/*************************************************************
 *                 bbomberman                                *
 *  (c) 2004 by Bernhard Eder (bb-generation)                *
 *  http://bbgen.net/bomberman for updates                   *
 *  Webmaster@bbgen.net for bug reports and other stuff      *
 * --------------------------------------------------------- *
 * This program is free software; you can modify it under    *
 * the terms of the GNU General Public License as published  *
 * by the Free Software Foundation, located in LICENSE       *
 *                                                           *
 *************************************************************/


#ifndef INIT_H
#define INIT_H

#include <iostream>
#include <cstdio>
#include <string>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_ttf.h>
#include "cl_images.h"

#define IMG_DIR img



enum bb_init_server
{
  BB_INIT_SERVER_LOCAL,
  BB_INIT_SERVER_NET,
  BB_INIT_SERVER_REMOTE
};

class cl_init
{
  friend class cl_game;
  friend class cl_bomb;
  friend class cl_player;
  public:
    bb_init_server  server_kind;
    std::string     server_hostname;
    unsigned int    playercount;
    std::string     names[4];
    unsigned int fX, fY; //Field X and Field Y..

    cl_init(void);
  protected:
  //general sizing stuff
    int iX, iY, iBit;  
    bool fullscreen;
    int iDspWidth;
  //SDL stuff
    SDL_Surface *screen;
  
    
};

#endif
