/*************************************************************
 *                 bbomberman                                *
 *  (c) 2004 by Bernhard Eder (bb-generation)                *
 *  http://bbgen.net/bomberman for updates                   *
 *  Webmaster@bbgen.net for bug reports and other stuff      *
 * --------------------------------------------------------- *
 * This program is free software; you can modify it under    *
 * the terms of the GNU General Public License as published  *
 * by the Free Software Foundation, located in LICENSE       *
 *                                                           *
 *************************************************************/
 
#include "cl_settings.h"

cl_settings::cl_settings(void)
{
  ReadSettings();
}

//There would be a WinAPI command for reading ini files.. but non portable stuff sucks ass
void cl_settings::ReadSettings(void)
{
//Sets std::cerr standard output on stderr.txt (better, because we don't want to
// see the sucking errors in the console.
/*  std::ofstream out("stderr.txt");
  std::streambuf* sbuf = std::cerr.rdbuf();
  std::cerr.rdbuf(out.rdbuf());*/
  
  std::ifstream FileIn("settings.ini"); 
  if (!FileIn) 
  {
    std::cerr << "Warning! error when trying to parse settings.ini. I will try to load default settings." << std::endl;
    if(LoadDefaultSettings()) std::cerr << "Info! successfully loaded default settings." << std::endl;
  }
  else
  {
    LoadDefaultSettings(); //If a value isn't set in the settings.ini
    int i=1;
    for (std::string ReadString; getline(FileIn, ReadString);i++)
      ParseLine(ReadString,i);
  }
//  std::cerr.rdbuf(sbuf);
}

//Parses 1 (!) line. if there is a undefined var in the settings.ini, there would be an warning
void cl_settings::ParseLine(std::string PLine, const unsigned line)
{
  std::string name, value;
  for(unsigned int i=0,t=0;i<PLine.length();i++)
  {
    if(PLine[i] == '=') 
    {
      t=1;
      continue; //'=' is senseless in value;
    }
    if(t==0) name+=PLine[i];
    else value+=PLine[i];
  }
//  std::cerr << "Name: " << name << " Value: " << value << std::endl;
  if(name.length()>1) //Parse it only if there is a name
  {
//    stringstream strn(name);
//    stringstream strv(value);
    if(name.substr(0,name.length()-1) == "bname")
    {
      std::stringstream stemp(name.substr(0,name.length()-1));
      unsigned int itemp;
      stemp >> itemp;
      bname[itemp] = value;
    }
    else if(name.substr(0,2) == "bk") //bomberman keys
    {
      std::stringstream stemp(name.substr(2,1));
      unsigned int itemp;
      stemp >> itemp;
      std::stringstream svalue(value);
      unsigned int ivalue;
      stemp >> ivalue;
      if(name.substr(3) == "left")
        bk[itemp][0] = SDLKey(ivalue);
      else if(name.substr(3) == "right")
        bk[itemp][1] = SDLKey(ivalue);
      else if(name.substr(3) == "up")
        bk[itemp][2] = SDLKey(ivalue);
      else if(name.substr(3) == "down")
        bk[itemp][3] = SDLKey(ivalue);
      else if(name.substr(3) == "bomb")
        bk[itemp][4] = SDLKey(ivalue);
      else std::cerr << "Error! Unknown bomberman key at line " << line << " of settings.ini." << std::endl;
    }
    else if(name.substr(0,1) != "#")
      std::cerr << "Warning! Undefined Var in settings.ini at line " << line << "." << std::endl;
  }
  else if(name.substr(0,1) != "#")
    std::cerr << "Warning! Undefined Name of Var in settings.ini at line " << line << "." << std::endl;
}

//left right up down bomb
//This only loads (!) the default settings. it doesn't save it!
bool cl_settings::LoadDefaultSettings(void)
{
  bk[0][0] = SDLK_LEFT; bk[0][1] = SDLK_RIGHT; bk[0][2] = SDLK_UP; bk[0][3] = SDLK_DOWN; bk[0][4] = SDLK_RETURN;
  bk[1][0] = SDLK_a; bk[1][1] = SDLK_d, bk[1][2] = SDLK_w, bk[1][3] = SDLK_s; bk[1][4] = SDLK_TAB;
  bk[2][0] = SDLK_n; bk[2][1] = SDLK_COMMA; bk[2][2] = SDLK_j; bk[2][3] = SDLK_m; bk[2][4] = SDLK_SPACE;
  bk[3][0] = SDLK_KP1; bk[3][1] = SDLK_KP3; bk[3][2] = SDLK_KP5; bk[3][3] = SDLK_KP2; bk[3][4] = SDLK_KP0; //Keypad
  return 1;
}

void cl_settings::SetWrite(std::ofstream& Settings, const char stwrite[])
{
//  Settings.Write("mwuah",6);
}

/*52 C:\schule\AINF\klasse1\sdl\bomberman\cl_settings.cpp
no matching function for call to `std::basic_ofstream<char,  std::char_traits<char> >::Write(const char*&, unsigned int)'
*/
